<template>
  <div>
    <table width="100%" style="height:30rem">
      <thead>
        <tr v-for="( itdata,index ) in fixdatahead" :key="index+'td'">
          <th class="p-5" colspan="10">
            <h3>
              <font v-if="itdata.TrainTypeCode === '10' ">
                <Icon type="md-train" />
                -{{ $t('components.trainborard.Shuttlebusfast') }}
              </font>
              <font v-if="itdata.TrainTypeCode === '7'  ">
                <Icon type="md-train" />
                -{{ $t('components.trainborard.normalfast') }}
              </font>
              <font v-if="itdata.TrainTypeCode === '6'  ">
                <Icon type="md-train" />
                -{{ $t('components.trainborard.Shuttlebus') }}
              </font>
              <font v-if="itdata.TrainTypeCode === '4'  ">
                <Icon type="md-train" style="color:#0069c2" />
                -{{ $t('components.trainborard.ChuKuang') }}
              </font>
              <font v-if="itdata.TrainTypeCode === '3'  ">
                <Icon type="md-train" style="color:orange" />
                -{{ $t('components.trainborard.TzeChiang') }}
              </font>
              <font v-if="itdata.TrainTypeCode === '2'  ">
                <Icon type="md-train" style="color:#d00216" />
                -{{ $t('components.trainborard.Puoma') }}
              </font>
              <font v-if="itdata.TrainTypeCode === '1'  ">
                <Icon type="md-train" style="color:#d00216" />
                -{{ $t('components.trainborard.TarokoExpress') }}
              </font>
              ({{ itdata.TrainNo }})-{{ $t('components.trainnote.from') }}{{itdata.StartingStationName.Zh_tw}} → {{ $t('components.trainnote.to') }}{{itdata.EndingStationName.Zh_tw}}
            </h3>
          </th>
        </tr>
        <tr>
          <th width="33%">{{ $t('components.trainnote.station') }}</th>
          <th width="33%">{{ $t('components.trainborard.arrivetime') }}</th>
          <th width="33%">{{ $t('components.trainborard.gotime') }}</th>
        </tr>
      </thead>
      <tbody class="tc">
        <tr v-for="( itdata2,index ) in historyData" :key="index+'td'">
          <td width="33%">{{ itdata2.StationName.Zh_tw }}</td>
          <td width="33%">{{ itdata2.ArrivalTime }}</td>
          <td width="33%">{{ itdata2.DepartureTime }}</td>
        </tr>
        <tr v-if="historyData == ''">
          <td colspan="10" class="tc p-5">{{ $t('trainborard.noform') }}</td>
        </tr>
      </tbody>
    </table>
    <Page
      class="mt-10 mb-10 fr"
      :total="dataCount"
      ref="pages" 
      :page-size="pageSize"
      simple
      @on-change="changepage"
    ></Page>
  </div>
</template>

<script>
import moment from "moment";
export default {
  props: {
    tableboard: {
      type: Array,
      default: () => ({
        TrainDate: String,
        DailyTrainInfo: {
          TrainNo: String,
          Direction: Number,
          StartingStationID: String,
          StartingStationName: {
            Zh_tw: String,
            En: String
          },
          EndingStationID: String,
          EndingStationName: {
            Zh_tw: String,
            En: String
          },
          TripHeadsign: String,
          TrainTypeID: String,
          TrainTypeCode: String,
          TrainTypeName: {
            Zh_tw: String,
            En: String
          },
          TripLine: Number,
          WheelchairFlag: Number,
          PackageServiceFlag: Number,
          DiningFlag: Number,
          BikeFlag: Number,
          BreastFeedingFlag: Number,
          DailyFlag: Number,
          ServiceAddedFlag: Boolean,
          Note: {
            Zh_tw: String
          }
        },
        StopTimes: [
          {
            StopSequence: Number,
            StationID: String,
            StationName: {
              Zh_tw: String,
              En: String
            },
            ArrivalTime: String,
            DepartureTime: String
          }
        ],
        UpdateTime: String,
        VersionID: Number
      })
    }
  },
  data() {
    return {
      ajaxHistoryData: [],
      // 初始化信息总条数
      dataCount: 0,
      // 每页显示多少条
      pageSize: 10,
      historyData: []
    };
  },
  computed: {
    fixdatahead() {
      const nowtime = moment(Date.now()).format("x")
      const fixheaddata = this.tableboard.map(item => Object.values(item)[1]);
      const fixheaddata2 = fixheaddata.filter(items => {
        // console.log(`A`, moment(seecltdate+' '+items.ArrivalTime).format("x"));
          return moment(this.tableboard[0].TrainDate +' '+items.ArrivalTime).format("x") > nowtime
      })
      return fixheaddata2;
    }
  },
  watch: {
    tableboard(val) {
      this.handleListApproveHistory();
    }
  },
  methods: {
    // 获取历史记录信息
    handleListApproveHistory() {
      if (this.tableboard.length != 0) {
        // 保存取到的所有数据
        const fixbodydata = this.tableboard.map(item => Object.values(item)[2]);
        this.ajaxHistoryData = fixbodydata[0];
        this.dataCount = fixbodydata[0].length;
        // 初始化显示，小于每页显示条数，全显，大于每页显示条数，取前每页条数显示
        if (fixbodydata[0].length < this.pageSize) {
          this.historyData = this.ajaxHistoryData;
        } else {
          this.historyData = this.ajaxHistoryData.slice(0, this.pageSize);
        }
      }
      this.$nextTick(()=>{
          this.$refs['pages'].currentPage = 1;
      })
    },
    changepage(index) {
      var _start = (index - 1) * this.pageSize;
      var _end = index * this.pageSize;
      this.historyData = this.ajaxHistoryData.slice(_start, _end);
    },
    detial(index) {
      // console.log(`this.historyData[index]`, this.historyData[index]);
      this.togglemodaldata(this.historyData[index]);
      this.togglemodalshow();
    }
  }
};
</script>
